-- UIErrorsFrame:AddMessage( "msg" ,0,1,.5,1,2)
-- string.find( UnitDebuff("target",i ), sDebuffName )
-- DEFAULT_CHAT_FRAME:AddMessage( "woot!" )


---------------------------------------------------------------------------------------------------
--- Table Tools --- Table Tools --- Table Tools --- Table Tools --- Table Tools --- Table Tools ---
---------------------------------------------------------------------------------------------------


-- Print contents of `tbl`, with indentation.
-- `indent` sets the initial level of indentation.
function tprint (tbl, indent)
	if not indent then indent = 1 end
	for k, v in pairs(tbl) do
		local formatting = string.rep("  ", indent) .. k .. ": "
		if type(v) == "table" then
			print(formatting)
			tprint(v, indent+1)
		elseif type(v) == 'boolean' then
			print(formatting .. tostring(v))      
		else
			print(formatting .. tostring(v))
		end
	end
end


function initTable(itable,...)
	--print(itable)
	--print(type(itable))
	
	if "table"~=type(itable) then
		error("initTable(itable,...) was not passed a table")
	end

	local n = select("#", ...)
	
	if n>=1 and not itable[select(1,...)] then
		itable[select(1,...)] = {}
	end
	
	if n>=2 and not itable[select(1,...)][select(2,...)] then
		itable[select(1,...)][select(2,...)] = {}
	end
	
	if n>=3 and not itable[select(1,...)][select(2,...)][select(3,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)] = {}
	end
	
	if n>=4 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)] = {}
	end
	
	if n>=5 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)] = {}
	end
	
	if n>=6 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)] = {}
	end
	
	if n>=7 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)] = {}
	end
	
	if n>=8 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)] = {}
	end
	
	if n>=9 and not itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)][select(9,...)] then
		itable[select(1,...)][select(2,...)][select(3,...)][select(4,...)][select(5,...)][select(6,...)][select(7,...)][select(8,...)][select(9,...)] = {}
	end
	
	--[[
	for i=1, n do
		local arg = select(i, ...)
		
		print(arg)
		itable
	end
	]]--
	
end


function tablelength(T)
	local count = 0
	for _ in pairs(T) do
		count = count + 1
	end
	return count
end


---------------------------------------------------------------------------------------------------
------- Text Chat Color ----- Text Chat Color -----  Text Chat Color -----  Text Chat Color -------
---------------------------------------------------------------------------------------------------



 function ColorText(red,green,blue)
	local red = tonumber( red )
	local green = tonumber( green )
	local blue = tonumber( blue )

	if type(red)=="number" and type(green)=="number" and type(blue)=="number" then
	if red<=0 then red=0 end
	if green<=0 then green=0 end
	if blue<=0 then blue=0 end

	if red<=1 and green<=1 and blue<=1 then
		red = red*256
		green = green*256
		blue = blue*256
	end

	red = round( red )
	green = round( green )
	blue = round( blue )

	if red>=255 then red=255 end
	if green>=255 then green=255 end
	if blue>=255 then blue=255 end

	return "\124cFF"..string.format("%02x%02x%02x", red, green, blue)
	else
	return "\124r"
	end
end


function round(fnumber,rnum)
	if not fnumber then return fnumber end
	if not rnum then rnum=0 end
	local rnum = -1 * rnum
	
	local divnum=10^rnum
	local returnval
	returnval=fnumber/divnum
	returnval=floor(returnval)
	returnval=returnval*divnum
	returnval=tonumber(returnval)
	
	return (returnval)
end



function ScrollToBottom()
    DEFAULT_CHAT_FRAME:ScrollToBottom() 
end


function addMsg(...)
	DEFAULT_CHAT_FRAME:AddMessage(...)
end



-- /script SendChatMessage("Hello Bob!", "WHISPER", "Common", "Bob");

function SendChatMessageInstance(pmsg)
	SendChatMessage(pmsg,"INSTANCE_CHAT")
end

function SendChatMessageParty(pmsg)
	SendChatMessage(pmsg,"PARTY")
end


function SendChatMessageWhisper(pmsg,person)
	SendChatMessage(pmsg,"WHISPER",nil,person)
end


---------------------------------------------------------------------------------------------------
------ Bank Inventory Containers --- Bank Inventory Containers --- Bank Inventory Containers ------
---------------------------------------------------------------------------------------------------

function scanContainers()

	-- numberOfSlots = GetContainerNumSlots(bagID);
	
	for bagID = 0, NUM_BAG_SLOTS do
		scanContainer(bagID)
	end
	
	--numberOfSlots = GetContainerNumSlots(BANK_CONTAINER);
	--print(numberOfSlots)
	scanContainer(BANK_CONTAINER)

	for bagID = NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+NUM_BANKBAGSLOTS do
		--numberOfSlots = GetContainerNumSlots(bagID);
		--print(numberOfSlots)
		scanContainer(bagID)
	end
end


function scanItems()
	for i=1,65536 do
		--itemId = GetInventoryItemID("unit", invSlot);
		local itemId = GetInventoryItemID("player", i)
		
		processItemId(itemId,"{"..i.."}")
	end
end


function scanContainer(bagID)
	local numberOfSlots = GetContainerNumSlots(bagID);
	--print(numberOfSlots)
	
	for slotID = 1, numberOfSlots do
		local itemId = GetContainerItemID(bagID, slotID);
		
		processItemId(itemId, "[" .. bagID .. "," .. slotID .. "]")
	end
end



function processItemId(itemId,msg)
	if itemId then
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId)

		if itemRarity==1 or itemRarity==2 or itemRarity==3 or itemRarity==4 then
			-- ignore
		elseif itemRarity==0 then
			print(msg .. "  " .. itemName .. "   <" .. itemRarity .. ">")
		else
			print(ColorText(255,0,0) .. msg .. "  " .. itemName .. "   <" .. itemRarity .. ">" .. ColorText())
		end
	end

end





function TableOfInventory()
	
	local inventoryTable = {}
	
		for i=1,39 do
			local itemId = GetInventoryItemID("player", i)
			
			if itemId then
				local itemLink = GetInventoryItemLink("player", i)
				inventoryTable["{"..i.."}"] = { itemId=itemId , count=1, itemLink=itemLink }
			end
		end
	
	for bagID = 0, NUM_BAG_SLOTS do
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end
	end
	
	local bagID = BANK_CONTAINER
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end

	for bagID = NUM_BAG_SLOTS+1, NUM_BAG_SLOTS+NUM_BANKBAGSLOTS do
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end
	end
	
	-- reagent bank slots
	local bagID = -3
		local numberOfSlots = GetContainerNumSlots(bagID);
		for slotID = 1, numberOfSlots do
			local itemId = GetContainerItemID(bagID, slotID);
			if itemId then
				local texture, itemCount, locked, quality, readable, lootable, itemLink = GetContainerItemInfo(bagID, slotID);
				inventoryTable["[" .. bagID .. "," .. slotID .. "]"] = { itemId=itemId , count=itemCount, itemLink=itemLink }
			end
		end

	return inventoryTable
end



function parseTableForHeirlooms()

	local toInventory = TableOfInventory()
	
	local heirTable = {}
	
	local count = 0
	
	--tprint(toInventory)
	
	for k in pairs(toInventory) do
		local data = toInventory[k]
		--tprint(data)
		local itemId = data.itemId
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId)
		
		if itemRarity==0 or itemRarity==1 or itemRarity==2 or itemRarity==3 or itemRarity==4 then
			-- ignore
			
		else
			--print( k .. "  " .. itemLink .. "   <" .. itemRarity .. ">" )
			count = count + 1
			heirTable[k] = itemName
			
		end
	end
	
	--print("Heirlooms found: " .. ColorText(255,0,0) .. count .. ColorText())
	
	return heirTable, count

end


---------------------------------------------------------------------------------------------------
----- Start Combat Aggro --- Start Combat Aggro --- Start Combat Aggro --- Start Combat Aggro -----
---------------------------------------------------------------------------------------------------




function numberPartyInCombat()
	local s = 0
	local who = nil

	for i = 0, 8 do
		local partyI = "party"..i
		local affectingCombat = UnitAffectingCombat(partyI);
		if affectingCombat then
			s = s + 1
			
			if who==nil then
				who = GetUnitName(partyI,true)
			else
				who = who .. ", " .. GetUnitName(partyI,true)
			end
		end
	end
	
	local partyI = "player"
	local affectingCombat = UnitAffectingCombat(partyI);
	if affectingCombat then
			s = s + 1
			
			if who==nil then
				who = GetUnitName(partyI,true)
			else
				who = who .. ", " .. GetUnitName(partyI,true)
			end
	end
	
	return s, who
end










---------------------------------------------------------------------------------------------------
------- Group Roles ----- Group Roles ----- Group Roles ----- Group Roles ----- Group Roles -------
---------------------------------------------------------------------------------------------------


function whoHealer()
	local s = 0
	local who = {}

	for i = 0, 8 do
		local partyI = "party"..i
		local role = UnitGroupRolesAssigned(partyI);
		if "HEALER"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	end
	
		local partyI = "player"
		local role = UnitGroupRolesAssigned(partyI);
		if "HEALER"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	
	return s, who
end



function whoTank()
	local s = 0
	local who = {}

	for i = 0, 8 do
		local partyI = "party"..i
		local role = UnitGroupRolesAssigned(partyI);
		if "TANK"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	end
	
		local partyI = "player"
		local role = UnitGroupRolesAssigned(partyI);
		if "TANK"==role then
			s = s + 1
			table.insert(who,partyI)
		end
	
	return s, who
end



function GetNumMembers()

	--[[
	local members = GetNumRaidMembers();
	
	if members==nil then
		members = -1
	end
	
	local partyMembers = GetNumPartyMembers()
	
	if partyMembers==nil then
		partyMembers = -1
	end
	
	if members > partyMembers then
		return members
	else
		return partyMembers
	end
	]]--
	
	return GetNumGroupMembers();

end





---------------------------------------------------------------------------------------------------
----- Party Raid Markers --- Party Raid Markers --- Party Raid Markers --- Party Raid Markers -----
---------------------------------------------------------------------------------------------------



-- /script if not GetRaidTargetIndex("target") then SetRaidTarget("target",7) end

function AutoPartyRaidTargetMarkers()

	for i = 0, 8 do
		local partyI = "party"..i
		AutoRaidTargetMarkMember(partyI)
	end
	
		AutoRaidTargetMarkMember("player")
	
end



function AutoRaidTargetMarkMember(memberID)
	
	if not GetRaidTargetIndex(memberID) then
	
		local role = UnitGroupRolesAssigned(memberID);
		
		if "TANK" == role then
		
			SetRaidTarget(memberID,1)
		
		elseif "HEALER" == role then
		
			SetRaidTarget(memberID,5)
		
		end
	
	end
	
end




---------------------------------------------------------------------------------------------------
---- Zone Info Text --- Zone Info Text --- Zone Info Text --- Zone Info Text --- Zone Info Text ---
---------------------------------------------------------------------------------------------------


function zoneInfo()
	
	local zoneName = GetZoneText();
	local subzone = GetSubZoneText();
	local minimapzonetext = GetMinimapZoneText();
	
	return ( zoneName .. " | " .. subzone .. " | " .. minimapzonetext )
end












---------------------------------------------------------------------------------------------------
---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ---- Macro Helpers ----
---------------------------------------------------------------------------------------------------


function xtarget()
	if UnitExists("target") and not GetRaidTargetIndex("target") then
		SetRaidTarget("target",7)
	end
end








---------------------------------------------------------------------------------------------------
--- Professions --- Professions --- Professions --- Professions --- Professions --- Professions ---
---------------------------------------------------------------------------------------------------

function printProfessions()

	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	
	if not firstAid then
		firstAid = ""
	end
	
	if not archaeology then
		archaeology = ""
	end
	
	print(prof1 .. " " .. prof2 .. " " .. archaeology .. " " .. fishing .. " " .. cooking .. " " .. firstAid )
	
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof1)
	print(name .. " " .. skillLevel .. " " .. maxSkillLevel )
	
	
	local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
	print(name .. " " .. skillLevel .. " " .. maxSkillLevel )
	
end




function TableOfProfessions()

	local profTable = {}

	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	
	if prof1 then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof1)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if prof2 then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if archaeology then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(archaeology)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if fishing then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(fishing)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if cooking then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(cooking)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	if firstAid then
		local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier, specializationIndex, specializationOffset = GetProfessionInfo(firstAid)
		profTable[name] = skillLevel .. " / " .. maxSkillLevel
	end
	
	return profTable
	
--	if table.getn(profTable)>0 then
--		return profTable
--	else
--		return nil
--	end
end




---------------------------------------------------------------------------------------------------
------- Frames --- Frames --- Frames --- Frames --- Frames --- Frames --- Frames --- Frames -------
---------------------------------------------------------------------------------------------------


--- PrintFramesRegisteredForEvent("PLAYERBANKSLOTS_CHANGED")
--- PrintFramesRegisteredForEvent("PLAYERBANKBAGSLOTS_CHANGED")

function PrintFramesRegisteredForEvent(evt)

	local num = select( "#", GetFramesRegisteredForEvent(evt) )
	print(ColorText(1,0,0)..num)
	for i = 1, num do
		local s = select( i, GetFramesRegisteredForEvent(evt) )
		print(ColorText(0,1,0)..i)
		tprint( s )
	end

end

function pfrfe()
	PrintFramesRegisteredForEvent("PLAYERBANKSLOTS_CHANGED")
	PrintFramesRegisteredForEvent("PLAYERBANKBAGSLOTS_CHANGED")
	PrintFramesRegisteredForEvent("BANKFRAME_OPENED")
end

function BankFrameIsVisible()
	return BankFrame:IsVisible()
end
